''' -----------------------------------------------------------------------------
''' Project	 : NHenry.Exception
''' Struct	 : Exception.SParam
''' 
''' -----------------------------------------------------------------------------
''' <summary>
''' Structure mmorisant une valeur et son nom
''' </summary>
''' -----------------------------------------------------------------------------
Public Structure SParam
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Initialise les attributs de la structure
    ''' </summary>
    ''' <param name="pName">Nom de la valeur</param>
    ''' <param name="pObj">Valeur</param>
    ''' -----------------------------------------------------------------------------
    Public Sub New(ByVal pName As String, ByVal pObj As Object)
        Name = pName
        Objet = pObj
    End Sub
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Nom de la valeur
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Name As String
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Valeur
    ''' </summary>
    ''' -----------------------------------------------------------------------------
    Public Objet As Object
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne une chaine reprsentant la valeur
    ''' </summary>
    ''' <returns></returns>
    ''' -----------------------------------------------------------------------------
    Public Overrides Function ToString() As String
        If Name <> "" Then
            If Objet Is Nothing Then
                Return "Objet " + Name + ", Valeur : nothing"
            Else
                Return "Objet " + Name + ", Type (" + Objet.GetType.FullName + ") : " + ClsDescriptions.Description(Objet)
            End If
        Else
            If Objet Is Nothing Then
                Return "Objet <sans nom>, Valeur : nothing"
            Else
                Return "Objet <sans nom>, Type (" + Objet.GetType.FullName + ") : " + ClsDescriptions.Description(Objet)
            End If
        End If
    End Function
End Structure
