''' -----------------------------------------------------------------------------
''' Project	 : NHenry.Exception
''' Interface	 : Exception.IException
''' 
''' -----------------------------------------------------------------------------
''' <summary>
''' Interface utilise pour identifier les classes contenant des descriptions
''' </summary>
''' -----------------------------------------------------------------------------
Public Interface IException
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne le dtail d'une exception ou une chaine vide si rien
    ''' </summary>
    ''' <param name="pEx">Exception  traiter</param>
    ''' <param name="pParams">Paramtres au moment de l'exception</param>
    ''' <returns></returns>
    ''' <remarks>
    ''' pParams peut contenir le nom du fichier  problme par exemple.
    ''' </remarks>
    ''' -----------------------------------------------------------------------------
    Function GetDetail(ByVal pEx As System.Exception, ByVal pParams As ColParams) As String
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne la description d'une exception ou une chaine vide si rien
    ''' </summary>
    ''' <param name="pEx">Exception  traiter</param>
    ''' <param name="pParams">Paramtres au moment de l'exception</param>
    ''' <returns></returns>
    ''' <remarks>
    ''' pParams peut contenir le nom du fichier  problme par exemple.
    ''' </remarks>
    ''' -----------------------------------------------------------------------------
    Function GetDescription(ByVal pEx As System.Exception, ByVal pParams As ColParams) As String
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Retourne une description d'un objet ou une chaine vide si rien
    ''' </summary>
    ''' <param name="pObj">Objet  dcrire</param>
    ''' <returns></returns>
    ''' -----------------------------------------------------------------------------
    Function GetDescription(ByVal pObj As Object) As String
End Interface
